// item.cpp
// ackmed@gotwalls.com
#include "item.h"
#include "shopbot.h"
#include "MagicPrefix.h"
#include "MagicSuffix.h"
#include "Weapons.h"
#include "TextPatch.h"


ITEMSTRUCT *ParseItemDrop(BYTE *Packet, DWORD Length) {
	ITEMSTRUCT *item = new ITEMSTRUCT;
	TEXTPATCHSTRUCT *tpatch;

	BitFields iPacket(Packet,Length);	

	item->MessageID = iPacket.GetField(8);

	if(item->MessageID != ITEM_MESSAGEID_DROP) {
		delete item;
		return NULL;
	}
	
	item->Action = iPacket.GetField(8);
	if(item->Action != ITEM_ACTION_TO_STORE) {
		delete item;
		return NULL;
	}

	item->MessageSize = iPacket.GetField(8);
	item->ItemType = iPacket.GetField(8);

	// only care about weapons.
	if(item->ItemType != ITEM_ITEMTYPE_WEAPON && item->ItemType != ITEM_ITEMTYPE_BOW) {
		delete item;
		return NULL;
	}
	item->ItemID = iPacket.GetField(32);

	// flags
	item->isSocketsFull = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(3),3,iPacket.pos);
	item->isIdentified = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(1),1,iPacket.pos);
	item->isSwitchin = iPacket.GetField(1);
	item->isSwitchout = iPacket.GetField(1);
	item->isBroken = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(1),1,iPacket.pos);
	item->fromBelt = iPacket.GetField(1);
	item->hasSockets = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(1),1,iPacket.pos);
	item->isJustGenerated = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(2),2,iPacket.pos);
	item->isEar = iPacket.GetField(1);
	item->isStartitem = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(3),3,iPacket.pos);
	item->isMiscItem = iPacket.GetField(1);
	item->isEthereal = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(1),1,iPacket.pos);
	item->isPersonalized = iPacket.GetField(1);
	item->isGamble = iPacket.GetField(1);
	item->isRuneWord = iPacket.GetField(1);
	
	DebugItemBits(iPacket.GetField(5),5,iPacket.pos);
	item->MPQVersionField = iPacket.GetField(10);
	
	item->Location = iPacket.GetField(3);
	iPacket.GetField(4);
	item->PositionX = iPacket.GetField(4);
	item->PositionY = iPacket.GetField(4);
	iPacket.GetField(3);

	// is ear?  not exactly possible  
	if(item->isEar) {
		delete item;
		return NULL;
	}

	if(!item->isIdentified) {
		if(Debug == DEBUG_DEVEL) {
			server->GamePrintString("Item was unidentified");
		}
		delete item;
		return NULL;
	}
	// read in itemcode, its a string;
	item->ItemCode[0] = iPacket.GetField(8);
	item->ItemCode[1] = iPacket.GetField(8);
	item->ItemCode[2] = iPacket.GetField(8);
	item->ItemCode[3] = iPacket.GetField(8);

	// chomp off the space if it exists
	if(item->ItemCode[3] == ' ') {
		item->ItemCode[3] = '\0';
	} else {
		item->ItemCode[4] = '\0';
	}

	DebugItemBits(iPacket.GetField(8),8,iPacket.pos);
	DebugItemBits(iPacket.GetField(2),2,iPacket.pos);
	item->ItemLevel = iPacket.GetField(4);

	// only care about magic items.
	if(item->ItemLevel == ITEM_LEVEL_MAGIC) {
		if(item->ItemType == ITEM_ITEMTYPE_WEAPON || item->ItemType == ITEM_ITEMTYPE_BOW) {
			iPacket.GetField(2);
	} 
		
		WORD row;
		
		row = iPacket.GetField(11);	 // prefix
		if(row > 0) {
			item->MagicPrefix = GetMagicPrefixRowNumber(row);
			if(item->MagicPrefix != NULL) {
				if(item->MagicPrefix->Prefix == NULL) {
					item->PrefixName[0] = '\0';
					item->MagicPrefix = NULL;
					
				} else {
					tpatch = GetTextPatchKey(item->MagicPrefix->Prefix);
					if(tpatch != NULL && tpatch->Value != NULL) {
						if(Debug == DEBUG_DEVEL) {
							sprintf(DebugBuffer,"TextPatch: %s -> %s",item->MagicPrefix->Prefix,tpatch->Value);
							server->GamePrintString(DebugBuffer);
						}
						strcpy(item->PrefixName,tpatch->Value);
					} else {
						strcpy(item->PrefixName,item->MagicPrefix->Prefix);
						
					}
				}
			} else {
				item->PrefixName[0] = '\0';
				if(Debug == DEBUG_DEVEL) {
					sprintf(DebugBuffer,"MagicPrefix lookup returned NULL for row: %d",row);
					server->GamePrintString(DebugBuffer);
				}
			}
		} else {
			item->MagicPrefix = NULL;
			item->PrefixName[0] = '\0';
		}

		row = iPacket.GetField(11);	 // sugfix
		if(row > 0) {
			item->MagicSuffix = GetMagicSuffixRowNumber(row);
			if(item->MagicSuffix != NULL) {
				if(item->MagicSuffix->Suffix == NULL) {
					item->MagicSuffix = NULL;
					item->SuffixName[0] = '\0';
				} else {
					tpatch = GetTextPatchKey(item->MagicSuffix->Suffix);
					if(tpatch != NULL && tpatch->Value != NULL) {
						if(Debug == DEBUG_DEVEL) {
							sprintf(DebugBuffer,"TextPatch: %s -> %s",item->MagicSuffix->Suffix,tpatch->Value);
							server->GamePrintString(DebugBuffer);
						}
						strcpy(item->SuffixName,tpatch->Value);
					} else {
						strcpy(item->SuffixName,item->MagicSuffix->Suffix);
					}
				}
			} else {
				item->SuffixName[0] = '\0';
				if(Debug == DEBUG_DEVEL) {
					sprintf(DebugBuffer,"MagicSuffix lookup returned NULL for row: %d",row);
					server->GamePrintString(DebugBuffer);
				}
			}

		} else {
			item->MagicSuffix = NULL;
			item->SuffixName[0] = '\0';
		}

		if(item->ItemType == ITEM_ITEMTYPE_WEAPON || item->ItemType == ITEM_ITEMTYPE_BOW) {
			item->weapon = GetWeaponsCode(item->ItemCode);
	
			if(item->weapon != NULL && item->weapon->Name == NULL) {
				item->weapon = NULL;		
			}
			
			tpatch = GetTextPatchKey(item->ItemCode);
			if(tpatch != NULL && tpatch->Value != NULL) {
				if(Debug == DEBUG_DEVEL) {
					sprintf(DebugBuffer,"ItemCodePatch: %s -> %s",item->ItemCode,tpatch->Value);
					server->GamePrintString(DebugBuffer);
				}
				strcpy(item->BaseName,tpatch->Value);
			} else {
				if(item->weapon != NULL) {
					strcpy(item->BaseName,item->weapon->Name);
				} else {
					item->BaseName[0] = '\0';
				}
			}
		} else {
			item->BaseName[0] = '\0';
		}
		return item;
	} else {
		delete item;
		return NULL;
	}
}

void DumpItemStruct(ITEMSTRUCT *item) {

	char DumpString[1024];

	BOOL found = false;
	
	sprintf(DumpString,"%s","Item: ");
	
	if(item->PrefixName[0] != '\0') {
		sprintf(DumpString,"%s %s",DumpString,item->PrefixName);
	}
	
	if(item->BaseName[0] != '\0') {
		//	server->GamePrintString("Weapon->Name is not null");
			sprintf(DumpString,"%s %s",DumpString,item->BaseName);
		
	} else {
		sprintf(DumpString,"%s (%s)",DumpString,item->ItemCode); // cant lookup code!?
	}

	if(item->SuffixName[0] != '\0') {
		sprintf(DumpString,"%s %s",DumpString,item->SuffixName);
	}
	
	
	server->GamePrintString(DumpString);
	return;
	
}	

void DebugItemBits(BYTE data, BYTE size, DWORD pos) {
// fill me in!
	BYTE n;

	if(Debug == DEBUG_PACKET) {
		sprintf(DebugBuffer,"%d: ",pos);
		if(size > 8)
			size = 8;

		if(size != 8) {
			data = data<<(8 - size);
			
		}
		for(n = 0;n < size;n++) {
			if((data & 0x80) !=0)
			{
				sprintf(DebugBuffer,"%s1",DebugBuffer);
			}
			else
			{
				sprintf(DebugBuffer,"%s0",DebugBuffer);
			}
			data = data<<1;
		}
		server->GamePrintInfo(DebugBuffer);
	}
}
// from mousepad with some small mods
DWORD GetBitField(BYTE* data, DWORD pos, DWORD len, DWORD max) {
	// trying to read beyond the end of the packet

	if(pos + len > max) {

		// if we are already at or beyond the end of packet, return 0;
		if(pos >= max) {
			return 0;
		}
		// otherwise adjust len to all remaining bits
		if(Debug == DEBUG_PACKET) {
			sprintf(DebugBuffer,"Trying to read beyond eop. len:%d pos:%d max:%d",len,pos,max);
			server->GamePrintString(DebugBuffer);
		}
		len = max - pos;
	}

	return (DWORD)(*(unsigned __int64 *)(data+pos/8)<<(64-len-(pos&7))>>(64-len));
}